package com.hai.dao;

import com.hai.entity.HighDiscountPackageAgentCode;
import com.hai.entity.HighDiscountPackageAgentCodeExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface HighDiscountPackageAgentCodeMapper extends HighDiscountPackageAgentCodeMapperExt {
    @SelectProvider(type=HighDiscountPackageAgentCodeSqlProvider.class, method="countByExample")
    long countByExample(HighDiscountPackageAgentCodeExample example);

    @DeleteProvider(type=HighDiscountPackageAgentCodeSqlProvider.class, method="deleteByExample")
    int deleteByExample(HighDiscountPackageAgentCodeExample example);

    @Delete({
        "delete from high_discount_package_agent_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into high_discount_package_agent_code (discount_package_id, discount_package_name, ",
        "agent_id, agent_name, ",
        "discount_package_actual_id, discount_agent_batch_id, ",
        "code, qr_code, qr_code_url, ",
        "create_time, update_time, ",
        "`status`, op_id, op_name, ",
        "ext_1, ext_2, ext_3)",
        "values (#{discountPackageId,jdbcType=BIGINT}, #{discountPackageName,jdbcType=VARCHAR}, ",
        "#{agentId,jdbcType=BIGINT}, #{agentName,jdbcType=VARCHAR}, ",
        "#{discountPackageActualId,jdbcType=BIGINT}, #{discountAgentBatchId,jdbcType=BIGINT}, ",
        "#{code,jdbcType=VARCHAR}, #{qrCode,jdbcType=VARCHAR}, #{qrCodeUrl,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{opId,jdbcType=BIGINT}, #{opName,jdbcType=VARCHAR}, ",
        "#{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(HighDiscountPackageAgentCode record);

    @InsertProvider(type=HighDiscountPackageAgentCodeSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(HighDiscountPackageAgentCode record);

    @SelectProvider(type=HighDiscountPackageAgentCodeSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_package_id", property="discountPackageId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_package_name", property="discountPackageName", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_name", property="agentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_package_actual_id", property="discountPackageActualId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_agent_batch_id", property="discountAgentBatchId", jdbcType=JdbcType.BIGINT),
        @Result(column="code", property="code", jdbcType=JdbcType.VARCHAR),
        @Result(column="qr_code", property="qrCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="qr_code_url", property="qrCodeUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<HighDiscountPackageAgentCode> selectByExample(HighDiscountPackageAgentCodeExample example);

    @Select({
        "select",
        "id, discount_package_id, discount_package_name, agent_id, agent_name, discount_package_actual_id, ",
        "discount_agent_batch_id, code, qr_code, qr_code_url, create_time, update_time, ",
        "`status`, op_id, op_name, ext_1, ext_2, ext_3",
        "from high_discount_package_agent_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="discount_package_id", property="discountPackageId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_package_name", property="discountPackageName", jdbcType=JdbcType.VARCHAR),
        @Result(column="agent_id", property="agentId", jdbcType=JdbcType.BIGINT),
        @Result(column="agent_name", property="agentName", jdbcType=JdbcType.VARCHAR),
        @Result(column="discount_package_actual_id", property="discountPackageActualId", jdbcType=JdbcType.BIGINT),
        @Result(column="discount_agent_batch_id", property="discountAgentBatchId", jdbcType=JdbcType.BIGINT),
        @Result(column="code", property="code", jdbcType=JdbcType.VARCHAR),
        @Result(column="qr_code", property="qrCode", jdbcType=JdbcType.VARCHAR),
        @Result(column="qr_code_url", property="qrCodeUrl", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    HighDiscountPackageAgentCode selectByPrimaryKey(Long id);

    @UpdateProvider(type=HighDiscountPackageAgentCodeSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") HighDiscountPackageAgentCode record, @Param("example") HighDiscountPackageAgentCodeExample example);

    @UpdateProvider(type=HighDiscountPackageAgentCodeSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") HighDiscountPackageAgentCode record, @Param("example") HighDiscountPackageAgentCodeExample example);

    @UpdateProvider(type=HighDiscountPackageAgentCodeSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(HighDiscountPackageAgentCode record);

    @Update({
        "update high_discount_package_agent_code",
        "set discount_package_id = #{discountPackageId,jdbcType=BIGINT},",
          "discount_package_name = #{discountPackageName,jdbcType=VARCHAR},",
          "agent_id = #{agentId,jdbcType=BIGINT},",
          "agent_name = #{agentName,jdbcType=VARCHAR},",
          "discount_package_actual_id = #{discountPackageActualId,jdbcType=BIGINT},",
          "discount_agent_batch_id = #{discountAgentBatchId,jdbcType=BIGINT},",
          "code = #{code,jdbcType=VARCHAR},",
          "qr_code = #{qrCode,jdbcType=VARCHAR},",
          "qr_code_url = #{qrCodeUrl,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(HighDiscountPackageAgentCode record);
}