package com.hai.openApi.service.impl;

import com.alibaba.fastjson.JSONObject;
import com.hai.common.exception.ErrorCode;
import com.hai.common.exception.ErrorHelp;
import com.hai.common.exception.SysCode;
import com.hai.config.PetroConfig;
import com.hai.dao.ApiCouponMapper;
import com.hai.entity.ApiCoupon;
import com.hai.entity.ApiCouponExample;
import com.hai.entity.HighCouponCodeOther;
import com.hai.entity.HighUserCoupon;
import com.hai.openApi.service.ApiCouponService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Service("apiCouponService")
public class ApiCouponServiceImpl implements ApiCouponService {

    @Resource
    private ApiCouponMapper apiCouponMapper;

    @Override
    public void insertCoupon(ApiCoupon apiCoupon) {
        apiCouponMapper.insert(apiCoupon);
    }

    @Override
    public void editCoupon(ApiCoupon apiCoupon) {
        apiCouponMapper.updateByPrimaryKeySelective(apiCoupon);
    }

    @Override
    public ApiCoupon findCoupon(String code) {

        ApiCouponExample example = new ApiCouponExample();
        example.createCriteria().andCodeEqualTo(code).andStatusEqualTo(1);

        List<ApiCoupon> list = apiCouponMapper.selectByExample(example);

        if (list.size() > 0) {
            return list.get(0);
        }

        return null;
    }

    @Override
    public List<ApiCoupon> getCouponList(Map<String, Object> map) {

        ApiCouponExample example = new ApiCouponExample();
        example.createCriteria().andStatusEqualTo(1);

        return apiCouponMapper.selectByExample(example);
    }

}
